/*

  RFID PN532 NFC Module V3 (UID Reader)

  Parts required:
  - Arduino Board
  - RFID PN532 NFC Module V3
  - 13.56 MHz Card or Brick

  Programming by : René Rasmussen
  Website : www.it-teknolog.dk
  Contact : renerasmussen@it-teknolog.dk
  Date : 1 Feb 2020
  Version : v1.0

  Modulet kan købes hos www.arduinotech.dk

*/

#include <Wire.h>
#include <SPI.h>
#include <Adafruit_PN532.h>

#define PN532_SCK  (2)
#define PN532_MOSI (3)
#define PN532_SS   (4)
#define PN532_MISO (5)

Adafruit_PN532 nfc(PN532_SCK, PN532_MISO, PN532_MOSI, PN532_SS);

#if defined(ARDUINO_ARCH_SAMD)
#define Serial SerialUSB
#endif

void setup(void) {
#ifndef ESP8266
  while (!Serial);
#endif
  Serial.begin(9600);
  Serial.println("Place your RFID Card or Brick on to the reader...");

  nfc.begin();
}

void loop(void) {
  uint8_t success;
  uint8_t uid[] = { 0, 0, 0, 0, 0, 0, 0 };
  uint8_t uidLength;

  

  Serial.print("UID: ");

  success = nfc.readPassiveTargetID(PN532_MIFARE_ISO14443A, uid, &uidLength);
  nfc.PrintHex(uid, uidLength);

  if (uidLength == 4)
  {
    uint8_t keya[6] = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
    success = nfc.mifareclassic_AuthenticateBlock(uid, uidLength, 4, 0, keya);

    if (success)
    {
      uint8_t data[16];

      success = nfc.mifareclassic_WriteDataBlock (4, data);
      success = nfc.mifareclassic_ReadDataBlock(4, data);

      if (success)
      {
      }
      else {
        Serial.println("Problem reading card or Brick");
      }
      delay(1000);
    }
  }
}
